/*

	subproblema:
	CMIN[i][j] = costul minim pentru a aproviziona benzinariile 1, 2, ..., i folosind j depozite
	COST[i][j] = costul minim pentru a aproviziona benzinariile i, ..., j folosind un depozit

	relatia de recurenta:
	CMIN[i][j] = min{CMIN[i - l][k - 1] + COST[i - l + 1][j] | 1 <= l <= i}

	solutia:
	CMIN[N][K]

*/

#include <fstream>
#include <limits>
#define NMax 401
#define KMax 301
using namespace std;

int N, K;
int D[NMax], S[KMax];
int CTR[NMax][NMax], CMIN[NMax][KMax], PMIN[NMax][KMax], BMIN[NMax][NMax];
int INF = numeric_limits<int>::max();

void read()
{
	int i;
	ifstream fin("petrom.in");
	fin >> N >> K;
	for (i = 1; i <= N; ++i)
		fin >> D[i];
	fin.close();
}

void solve()
{
	int i, j, k, l;
	for (i = 1; i <= N; ++i)
		for (j = i; j <= N; ++j)
		{
			BMIN[i][j] = (j + i) / 2;
			for (k = i; k <= j; ++k)
				CTR[i][j] += abs(D[BMIN[i][j]] - D[k]);
		}
	for (i = 1; i <= N; ++i)
		CMIN[i][1] = CTR[1][i];
	for (i = 1; i <= N; ++i)
		for (k = 2; k <= K && k <= i; ++k)
		{
			CMIN[i][k] = INF;
			for (l = 1; i - l >= k - 1; ++l)
				if (CMIN[i][k] > CMIN[i - l][k - 1] + CTR[i - l + 1][i])
				{
					CMIN[i][k] = CMIN[i - l][k - 1] + CTR[i - l + 1][i];
					PMIN[i][k] = i - l;
				}
		}
	for (i = N, k = K; k >= 1; i = PMIN[i][k--])
		S[k] = BMIN[PMIN[i][k] + 1][i];
}

void write()
{
	int k;
	ofstream fout("petrom.out");
	fout << CMIN[N][K] << '\n';
	for (k = 1; k <= K; ++k)
		fout << S[k] << '\n';
	fout.close();
}

int main()
{
	read();
	solve();
	write();
	return 0;
}
